#include <Windows.h>
#include "sqlite3.h"
#include "mysys.h"
#include "Resource.h"

int SQL(int flag, char* sql_code, HWND Main_hWnd)
{
	HWND hWnd;
	HINSTANCE hDll;

	pOpen sqlite3_open;
	pExec sqlite3_exec;
	pGetTable sqlite3_get_table;
	pFreeTable sqlite3_free_table;
	pClose sqlite3_close;
	pPrePare sqlite3_prepare;
	pStep sqlite3_step;
	pReset sqlite3_reset;
	pColumnint sqlite3_column_int;
	pErrmsg sqlite3_errmsg;
	pFree sqlite3_free;

	sqlite3* db;
	char* err = NULL;
	int ret;
	char* sql_string;
	char sql_str[1024];
	char str_param[MAX_PATH];
	char** result;
	int row;
	int col;

	hWnd = NULL;
	hDll = NULL;

	hDll = LoadLibrary("sqlite3");

	if (hDll == NULL)
	{
		MessageBox(hWnd, (LPCSTR)"sqlite3.dllQƂł܂łB\nPathmFĂ", (LPCSTR)"ERROR CODE 1001", MB_OK);
		return FALSE;
	}
	else
	{
		sqlite3_open = (pOpen)GetProcAddress(hDll, "sqlite3_open");
		sqlite3_exec = (pExec)GetProcAddress(hDll, "sqlite3_exec");
		sqlite3_get_table = (pGetTable)GetProcAddress(hDll, "sqlite3_get_table");
		sqlite3_free_table = (pFreeTable)GetProcAddress(hDll, "sqlite3_free_table");
		sqlite3_close = (pClose)GetProcAddress(hDll, "sqlite3_close");
		sqlite3_prepare = (pPrePare)GetProcAddress(hDll, "sqlite3_prepare");
		sqlite3_step = (pStep)GetProcAddress(hDll, "sqlite3_step");
		sqlite3_reset = (pReset)GetProcAddress(hDll, "sqlite3_reset");
		sqlite3_column_int = (pColumnint)GetProcAddress(hDll, "sqlite3_column_int");
		sqlite3_errmsg = (pErrmsg)GetProcAddress(hDll, "sqlite3_errmsg");
		sqlite3_free = (pFree)GetProcAddress(hDll, "sqlite3_free");

		sqlite3_open("SW_Info.db", &db);

		ret = SQLITE_OK;

		if (flag == START)
		{
			sql_string = "select * from SW_PATH;";
			ret = sqlite3_exec(db, sql_string, NULL, NULL, &err);

			if (ret != SQLITE_OK)
			{
				sql_string = "create table SW_PATH(swPath TEXT);";
				ret = sqlite3_exec(db, sql_string, NULL, NULL, &err);
				if (ret != SQLITE_OK)
				{
					MessageBox(hWnd, (LPCSTR)sqlite3_errmsg(hDll), (LPCSTR)"ERROR 0002", MB_OK);
					sqlite3_close(db);
					sqlite3_free(err);
					FreeLibrary(hDll);
					return FALSE;
				}

				ret = SQLITE_OK;
				sql_string = "insert into SW_PATH values('C:\\Program Files (x86)\\DataPower\\Save Wizard for PS4 MAX\\SWPS4MAX.exe');";
				ret = sqlite3_exec(db, sql_string, NULL, NULL, &err);
				if (ret != SQLITE_OK)
				{
					MessageBox(hWnd, (LPCSTR)sqlite3_errmsg(hDll), (LPCSTR)"ERROR 0003", MB_OK);
					sqlite3_close(db);
					sqlite3_free(err);
					FreeLibrary(hDll);
					return FALSE;
				}

				ret = SQLITE_OK;
				sql_string = "create table SW_CODE(SW_Code TEXT);";
				ret = sqlite3_exec(db, sql_string, NULL, NULL, &err);
				if (ret != SQLITE_OK)
				{
					MessageBox(hWnd, (LPCSTR)sqlite3_errmsg(hDll), (LPCSTR)"ERROR 0004", MB_OK);
					sqlite3_close(db);
					sqlite3_free(err);
					FreeLibrary(hDll);
					return FALSE;
				}
			}
		}
		else if (flag == PATH_VIEW)
		{
			sql_string = "select * from SW_PATH;";
			ret = sqlite3_get_table(db, sql_string, &result, &row, &col, &err);
			if (ret != SQLITE_OK)
			{
				MessageBox(hWnd, (LPCSTR)sqlite3_errmsg(hDll), (LPCSTR)"ERROR 0005", MB_OK);
				sqlite3_close(db);
				sqlite3_free(err);
				FreeLibrary(hDll);
				return FALSE;
			}

			SetDlgItemText(Main_hWnd, IDC_EDIT_BOX, (LPCSTR)result[1]);
			sqlite3_free_table(result);
		}
		else if (flag == PATH_EDIT)
		{
			GetDlgItemText(Main_hWnd, IDC_EDIT_BOX, (LPCSTR)str_param, sizeof(str_param));

			if (strcmp(str_param, "") == 0)
			{
				MessageBox(hWnd, (LPCSTR)"SaveWizardPathw肵ĂB", (LPCSTR)"ERROR 0006", MB_OK);
				sqlite3_close(db);
				sqlite3_free(err);
				FreeLibrary(hDll);
				return FALSE;
			}

			wsprintf(sql_str,"update SW_PATH set swPath = '%s';", str_param);
			MessageBox(hWnd, (LPCSTR)sql_str, (LPCSTR)"test", MB_OK);
			//ret = sqlite3_exec(db, sql_str, NULL, NULL, &err);
			if (ret != SQLITE_OK)
			{
				MessageBox(hWnd, (LPCSTR)sqlite3_errmsg(hDll), (LPCSTR)"ERROR 0007", MB_OK);
				sqlite3_close(db);
				sqlite3_free(err);
				FreeLibrary(hDll);
				return FALSE;
			}
		}

		sqlite3_close(db);
		FreeLibrary(hDll);
	}

	return TRUE;
}
